#include "ckalkulacka.h"
#include "ui_form.h"

CKalkulacka::CKalkulacka(QWidget *parent)
    : QDialog(parent), ui(new Ui::CKalkulacka)
{
    ui->setupUi(this);

    l_first = 0;
    l_second = 0;
    l_finish = 0;
    l_operator = -1;

    ui->VYSLEDEK->setText("0");
}

CKalkulacka::~CKalkulacka()
{
    delete ui;
}

void CKalkulacka::on_CLEAR_released()
{
    l_first = 0;
    l_second = 0;
    l_finish = 0;
    l_operator = -1;

    ui->VYSLEDEK->setText("0");
    SetDisableAll(false);
}

void CKalkulacka::on_JEDNA_released()
{
    QString a_str = ui->VYSLEDEK->text();

    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str == "0" && a_str != "-0")
        a_str = "1";
    else if (a_str == "-0")
        a_str = "-1";
    else
        a_str += "1";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_NULA_released()
{
    QString a_str = ui->VYSLEDEK->text();

    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str.length() > 1 && a_str != "-0" || a_str != "0" && a_str != "-0")
        a_str += "0";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_DVA_released()
{
    QString a_str = ui->VYSLEDEK->text();
    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str == "0" && a_str != "-0")
        a_str = "2";
    else if (a_str == "-0")
        a_str = "-2";
    else
        a_str += "2";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_TRI_released()
{
    QString a_str = ui->VYSLEDEK->text();
    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

   if (a_str == "0" && a_str != "-0")
        a_str = "3";
    else if (a_str == "-0")
        a_str = "-3";
    else
        a_str += "3";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_CTYRI_released()
{
    QString a_str = ui->VYSLEDEK->text();
    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str == "0" && a_str != "-0")
        a_str = "4";
    else if (a_str == "-0")
        a_str = "-4";
    else
        a_str += "4";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_PET_released()
{
    QString a_str = ui->VYSLEDEK->text();
    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str == "0" && a_str != "-0")
        a_str = "5";
    else if (a_str == "-0")
        a_str = "-5";
    else
        a_str += "5";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_SEST_released()
{
    QString a_str = ui->VYSLEDEK->text();
    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str == "0" && a_str != "-0")
        a_str = "6";
    else if (a_str == "-0")
        a_str = "-6";
    else
        a_str += "6";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_SEDM_released()
{
    QString a_str = ui->VYSLEDEK->text();
    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str == "0" && a_str != "-0")
        a_str = "7";
    else if (a_str == "-0")
        a_str = "-7";
    else
        a_str += "7";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_OSM_released()
{
    QString a_str = ui->VYSLEDEK->text();
    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str == "0" && a_str != "-0")
        a_str = "8";
    else if (a_str == "-0")
        a_str = "-8";
    else
        a_str += "8";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_DEVET_released()
{
    QString a_str = ui->VYSLEDEK->text();
    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str == "0" && a_str != "-0")
        a_str = "9";
    else if (a_str == "-0")
        a_str = "-9";
    else
        a_str += "9";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_pushButton_6_released()
{
    QString a_str = ui->VYSLEDEK->text();
    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str.indexOf(".") == -1 && a_str.indexOf(",") == -1)
        a_str += ".";
    else
        return;

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_pushButton_5_released()
{
    QString a_str = ui->VYSLEDEK->text();
    if (a_str == "+" || a_str == "-" || a_str == "/" || a_str == "*")
        a_str = "0";

    if (a_str.indexOf("-") != -1)
        a_str.remove(0, 1);
    else
        a_str = "-"+a_str;

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->pushButton_3->setDisabled(false);
    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_pushButton_7_released()
{
    QString a_str = ui->VYSLEDEK->text();

    l_first = a_str.toDouble();
    l_operator = 1;
    ui->pushButton_3->setDisabled(true);

    ui->VYSLEDEK->setText("+");
}

void CKalkulacka::on_pushButton_8_released()
{
    QString a_str = ui->VYSLEDEK->text();

    l_first = a_str.toDouble();
    l_operator = 2;
    ui->pushButton_3->setDisabled(true);

    ui->VYSLEDEK->setText("-");
}

void CKalkulacka::on_pushButton_9_released()
{
    QString a_str = ui->VYSLEDEK->text();

    l_first = a_str.toDouble();
    l_operator = 3;
    ui->pushButton_3->setDisabled(true);

    ui->VYSLEDEK->setText("*");
}

void CKalkulacka::on_pushButton_10_released()
{
    QString a_str = ui->VYSLEDEK->text();

    l_first = a_str.toDouble();
    l_operator = 4;
    ui->pushButton_3->setDisabled(true);

    ui->VYSLEDEK->setText("/");
}

void CKalkulacka::on_ROVNASE_released()
{
    char a_buffer[255];

    switch(l_operator)
    {
        case 1:
            l_finish = l_first + l_second;
            sprintf(a_buffer, "%g", (double)l_finish);
            ui->VYSLEDEK->setText(a_buffer);
            ui->pushButton_3->setDisabled(true);
            break;
        case 2:
            l_finish = l_first - l_second;
            sprintf(a_buffer, "%g", (double)l_finish);
            ui->VYSLEDEK->setText(a_buffer);
            ui->pushButton_3->setDisabled(true);
            break;
        case 3:
            l_finish = l_first * l_second;
            sprintf(a_buffer, "%g", (double)l_finish);
            ui->VYSLEDEK->setText(a_buffer);
            ui->pushButton_3->setDisabled(true);
            break;
        case 4:
            if (l_second != 0)
            {
                l_finish = l_first / l_second;
                sprintf(a_buffer, "%g", (double)l_finish);
                ui->VYSLEDEK->setText(a_buffer);
                ui->pushButton_3->setDisabled(true);
            }
            else
            {
                ui->VYSLEDEK->setText("error");
                ui->pushButton_3->setDisabled(true);
                SetDisableAll(true);
            }

            break;
    }
}

void CKalkulacka::on_pushButton_3_released()
{
    QString a_str = ui->VYSLEDEK->text();

    if (a_str.length() > 2 || (a_str.length() == 2 && a_str.indexOf("-") == -1))
        a_str.remove(a_str.length()-1, 1);
    else if (a_str.length() == 1 || (a_str.length() == 2 && a_str.indexOf("-") != -1))
        a_str = "0";

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::on_pushButton_2_released()
{
    QString a_str("0");

    if (l_operator == -1)
    {
        l_first = a_str.toDouble();
    }
    else
        l_second = a_str.toDouble();

    ui->VYSLEDEK->setText(a_str);
}

void CKalkulacka::SetDisableAll(bool a_enabled)
{
    ui->JEDNA->setDisabled(a_enabled);
    ui->DVA->setDisabled(a_enabled);
    ui->TRI->setDisabled(a_enabled);
    ui->CTYRI->setDisabled(a_enabled);
    ui->PET->setDisabled(a_enabled);
    ui->SEST->setDisabled(a_enabled);
    ui->SEDM->setDisabled(a_enabled);
    ui->OSM->setDisabled(a_enabled);
    ui->DEVET->setDisabled(a_enabled);
    ui->NULA->setDisabled(a_enabled);
    ui->pushButton_10->setDisabled(a_enabled);
    ui->pushButton_2->setDisabled(a_enabled);
    ui->pushButton_3->setDisabled(a_enabled);
    ui->pushButton_5->setDisabled(a_enabled);
    ui->pushButton_6->setDisabled(a_enabled);
    ui->pushButton_9->setDisabled(a_enabled);
    ui->pushButton_8->setDisabled(a_enabled);
    ui->pushButton_7->setDisabled(a_enabled);
    ui->ROVNASE->setDisabled(a_enabled);
}

void CKalkulacka::keyPressEvent ( QKeyEvent * event )
{
}
