#ifndef CKALKULACKA_H
#define CKALKULACKA_H

#include <QtGui/QDialog>
#include <QKeyEvent>

namespace Ui
{
    class CKalkulacka;
}

class CKalkulacka : public QDialog
{
    Q_OBJECT

public:
    CKalkulacka(QWidget *parent = 0);
    ~CKalkulacka();

protected:
    long double     l_first;
    long double     l_second;
    long double     l_finish;
    short           l_operator;
    void            SetDisableAll(bool a_enabled);
    virtual         void keyPressEvent ( QKeyEvent * event );

private:
    Ui::CKalkulacka *ui;

private slots:
    void on_pushButton_10_released();
    void on_pushButton_9_released();
    void on_pushButton_8_released();
    void on_pushButton_2_released();
    void on_pushButton_3_released();
    void on_ROVNASE_released();
    void on_pushButton_7_released();
    void on_pushButton_5_released();
    void on_pushButton_6_released();
    void on_DEVET_released();
    void on_OSM_released();
    void on_SEDM_released();
    void on_SEST_released();
    void on_PET_released();
    void on_CTYRI_released();
    void on_TRI_released();
    void on_DVA_released();
    void on_NULA_released();
    void on_JEDNA_released();
    void on_CLEAR_released();
};

#endif // CKALKULACKA_H
